/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *	p(SK502LCD\)
 *
 * \par Application note:
 *	AVR065: STK502pLCDײ
 *
 * \par Documentation:
 *	IȺގAxׁ߲A߲אݒAx޲ɂĂreadme.html
 *	B
 *
 * \author
 *	Atmel Corporation: http://www.atmel.com \n
 *	xEҰ: avr@atmel.com
 *
 * $Name: RELEASE_1_1 $
 * $Revision: 1.3 $
 * $RCSfile: main.c,v $
 * $Date: 2006/02/16 18:14:01 $  \n
 ******************************************************************************/

// ݸٰ ̧
#include "defines.h"
#include "LCD_driver.h"
#include <inavr.h>

/*! \brief	 ۯނLCDۯɈˑx̐
 *
 *  \param	delay	- ċN麰ގsx点邽߂LCDڰѐ
 */
void LCD_timerDelay( unsigned char delay )
{
  __disable_interrupt();						// S̊荞݋֎~
  LCD_timer = delay;							// LCDXVԊuݒ(Ԋu=delay~(1/LCDڰёx))
  LCD_status.updateComplete = FALSE;			// LCD荞ݏς݂𒲂ׂ邽߂ɍXV׸ނ
  LCD_status.updateRequired = TRUE;				// LCD荞݂ɍXV׸ނݒ肳邽߂ɍXVv׸ނݒ
  __enable_interrupt();							// S̊荞݋
  while( !LCD_status.updateComplete );			// XVҋ@(܂LCD\ޯ̧XVĂ͂Ȃ܂B)
}

/*! \brief	喳JԂ܂ގ֐
 */
#define DELAY1 64
#define DELAY2 5

void main(void)
{
  unsigned char counter;
  unsigned char testString[] = "STK502";
  LCD_Init();									// LCD
  __enable_interrupt();							// S̊荞݋

  for(;;)										// JԂ
  {
	//----------------------------------------------------------
	// LCD\Ɏ\
	//----------------------------------------------------------
	for (counter = 0; counter < 6; counter++ )	// 6\
	{
	  while( !LCD_status.updateComplete );		// XVҋ@(܂LCD\ޯ̧XVĂ͂Ȃ܂B)
	  LCD_status.updateRequired = FALSE;		// LCD\ޯ̧ LCDXVh~̂߂ɍXVv׸ނ
	  LCD_WriteDigit( *(testString + counter), counter+2 );		// LCD_displayDataޯ̧ɑΉ1
	  LCD_status.updateComplete = FALSE;			// ̍XV̂߂ɍXV׸ނ
	  LCD_status.updateRequired = TRUE;			// XVv׸ސݒ(LCDXVh~)
	}
	while( !LCD_status.updateComplete );		// XVҋ@

	//----------------------------------------------------------
	// LCD̺(:)_
	//----------------------------------------------------------
	LCD_status.updateRequired = FALSE;		// LCD\ޯ̧ LCDXVh~̂߂ɍXVv׸ނ
	LCD_SET_COLON(TRUE);					// LCD̺(:)\
	LCD_timerDelay( DELAY1 );				// 1bx

	LCD_status.updateRequired = FALSE;		// LCD\ޯ̧ LCDXVh~̂߂ɍXVv׸ނ
	LCD_SET_COLON(FALSE);					// LCD̺(:)\
	LCD_timerDelay( DELAY1 );				// 1bx

	//----------------------------------------------------------
	// ZWقŏˍőˍŏ˕Wɕω
	//----------------------------------------------------------
	for(counter = 0x00; counter < 0x0F; counter++)		// ŏˍőւ̕ω
	{
	  LCD_CONTRAST_LEVEL(counter);						// ΉLCDZWlݒ
	  LCD_timerDelay( DELAY2 );							// 80msҋ@
	}
	for(counter = 0x0F; counter != 0x00; counter--)		// őˍŏւ̕ω
	{
	  LCD_CONTRAST_LEVEL(counter);						// ΉLCDZWlݒ
	  LCD_timerDelay( DELAY2 );							// 80msҋ@
	}
	LCD_CONTRAST_LEVEL( LCD_INITIAL_CONTRAST );			// LCDZWllɐݒ

	//----------------------------------------------------------
	// 1LCDXVł̑SLCD'-'\
	//----------------------------------------------------------
	while( !LCD_status.updateComplete );		// XVҋ@(܂LCD\ޯ̧XVĂ͂Ȃ܂B)
	LCD_status.updateRequired = FALSE;			// LCD\ޯ̧ LCDXVh~̂߂ɍXVv׸ނ
	for (counter = 2; counter < 8; counter++ )	// S'-'w
	{
	  LCD_WriteDigit( '-', counter );			// Ή'-'LCD_displayDataޯ̧ɐݒ
	}
	LCD_status.updateRequired = TRUE;			// XVv׸ސݒ(LCDXVh~)
	while( !LCD_status.updateComplete );		// XVҋ@
  }
}

/* Doxygen documentation mainpage ********************************************/
/*! \mainpage
 * \section intro Introduction
 * AVR065pLqpĳ̎łBSTK502pײނłB
 *
 * \section compinfo ُ߲
 * IAR Embedded Workbench 4.12Aź߲ق܂BGCCgpɂͿ
 * ύXȂ΂Ȃ܂B\n
 * IAR EWAVRۼުĂ쐬ɂ́A\n
 * ۼުĂ.ç(main.cLCD_driver.c)ǉĂB"device --cpu=m169"
 * "enable bit definitions in I/O include files"Aޯޗpɏo͌`ubrof8A
 * opintel_extendedgpĂB\n
 *
 * \section deviceinfo ޲
 * ATmega169(P)pɏĂ܂ATmega329(P)ATmega649(P)ɉ邱
 * ł܂B
 *
 * \section contactinfo Contact Info
 * ATMELAVRɂĂ̂葽̏ɊւĂ͈ȉK˂ĂB
 * <A href="http://www.atmel.com/products/AVR/" >Atmel AVR</A> \n
 * pLqɊւĂ:
 * <A href="http://www.atmel.com/dyn/products/app_notes.asp?family_id=607">AVR Application Notes</A>\n
 * xҰ: avr@atmel.com
 */
